<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css,table.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">

function createMissingItems()
{
	init('Install');
}

function init(cmd)
{
	var request = Ajax.getXmlHttpRequest();
	var url = '../Install.servlet?ID=<%=ID%>&cmd='+cmd;
	request.open("GET", url, false); 
	request.send(null);
	
	var response = JSON.parse(request.responseText);
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	var COL_BREAKS = ['ANNOTATIONTYPE', 'PLUGINDEFINITION'];
	
	var numMissing = 0;
	var numWarnings = 0;
	var numErrors = 0;
	var numIncomplete = 0;
	var checks = response.checks;
	var html = '<table class="report">';
	var lastItemType = null;
	var index = 0;
	var first10 = '';
	var theRest = '';
	var allOk = true;
	
	for (var i = 0; i < checks.length; i++)
	{
		var check = checks[i];
		var icon = 'ok.png';
		if (check.status == 'missing') 
		{
			numMissing++;
			icon = 'error.png';
			allOk = false;
		}
		if (check.status == 'incomplete')
		{
			numIncomplete++;
			icon = 'warning.png';
			allOk = false;
		}
		if (check.status == 'error') 
		{
			numErrors++;
			icon = 'error.png';
			allOk = false;
		}
		if (check.status == 'warning') 
		{
			numWarnings++;
			icon = 'warning.png';
			allOk = false;
		}
		
		if (lastItemType != check.itemType)
		{
			html += first10;
			if (allOk && index > 13)
			{
				html += '<tr class="sameitemtype highlight" id="'+check.itemType+'" onclick="showMore(event)">';
				html += '<td class="link">&hellip; '+(index-10)+' more</td>';
				html += '<td><img src="../images/ok.png"></td><td>Ok</td></tr>';
				html += '<tbody id="'+check.itemType+'.more" style="display: none;">';
				html += theRest;
				html += '</tbody>';
			}
			else
			{
				html += theRest;
			}
			
			first10 = '';
			theRest = '';
			allOk = true;
			index = 0;
			
			var col_break = COL_BREAKS.indexOf(check.itemType);
			if (col_break >= 0)
			{
				// End the left side and start on the right
				html += '</table>';
				setInnerHTML('validationResult'+col_break, html);
				html = '<table class="report">';
			}
			html += '<tr class="newitemtype"><td colspan="3">'+check.itemType+'</td></tr>';
		}
		
		var line = '<tr class="sameitemtype highlight">';
		lastItemType = check.itemType;
		var name = check.name;
		if (check.mainType) name += ' <span class="itemsubtype">[' + check.mainType + ']</span>'; 
		if (check.id)
		{
			line += '<td class="itemTypeCol"><div class="link" onclick="itemOnClick(event, \''+check.itemType+'\','+check.id+')"';
			line += ' title="View this item (use CTRL, ALT or SHIFT to edit)">'+name+'</div></td>';
		}
		else
		{
			line += '<td class="itemTypeCol"><i>' + name + '</i></td>';
		}
		line += '<td class="iconCol"><img src="../images/'+icon+'"></td>';
		line += '<td class="statusCol">';
		if (check.messages.length > 1)
		{
			for (var m = 0; m < check.messages.length; m++)
			{
				line += '• '+check.messages[m] + '<br>';
			}
		}
		else
		{
			line += check.messages;
		}
		line += '</td></tr>';
		
		if (index < 10)
		{
			first10 += line;
		}
		else
		{
			theRest += line;
		}
		index++;
	}
	
	html += first10;
	if (allOk && index > 13)
	{
		html += '<tr class="sameitemtype highlight" id="'+check.itemType+'" onclick="showMore(event)">';
		html += '<td class="link">&hellip; '+(index-10)+' more</td>';
		html += '<td><img src="../images/ok.png"></td><td>Ok</td></tr>';
		html += '<tbody id="'+check.itemType+'.more" style="display: none;">';
		html += theRest;
		html += '</tbody>';
	}
	else
	{
		html += theRest;
	}
	
	html += '</table>';
	setInnerHTML('validationResult'+COL_BREAKS.length, html);
	
	if (numErrors > 0)
	{
		setFatalError(numErrors+' errors was detected. You need to fix those manually.');	
	}
	else if (numWarnings > 0)
	{
		setWarningMessage(numWarnings+' warnings was detected. Reggie may still work. If not, you need to fix it manually.');	
	}
	Main.showHide('createMissingItems', numMissing > 0);
	Main.showHide('fixIncompleteItems', numMissing == 0 && numIncomplete > 0);
}

function setWarningMessage(message)
{
	setInnerHTML('warningMessage.message', message);
	Main.show('warningMessage');
}

function itemOnClick(event, itemType, itemId)
{
	Main.itemOnClick(event, '<%=ID%>', itemType, itemId, true);
}

function showMore(event)
{
	var target = event.currentTarget;
	Main.show(target.id + '.more');
	Main.hide(target.id);
}

</script>
<style>
.report
{
	width: 100%;
	border-collapse: collapse;
}

.report .itemTypeCol
{
	width: 18em;
	overflow: hidden;
	text-overflow: ellipsis;
}

.report .iconCol
{
	width: 20px;
}
.report .statusCol
{}


.report th
{
	font-weight: bold;
	text-align: left;
	background: #E8E8E8;
	padding: 2px 4px 2px 4px;
}

.report td
{
	padding: 2px;
}

.report .newitemtype 
{
	border-top: 1px solid #A0A0A0;
	border-bottom: 1px solid #A0A0A0;
	font-weight: bold;
	background-color: #E8E8E8;
}
.report .sameitemtype 
{
	border-top: 1px dotted #A0A0A0;
	border-bottom: 1px dotted #A0A0A0;
}

.report .sameitemtype > td:first-child
{
	padding-left: 1em;
}

.report td 
{
	white-space: nowrap;
	overflow: hidden;
	text-overflow: ellipsis;
}
</style>
</base:head>
<base:body onload="init('Validate')">

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Installation wizard" 
		/></p:path>

	<div class="content" style="padding-left: 2em;">

		<div class="absolutefull" style="width: 33%; bottom: 10em;">
			<div id="validationResult0" class="absolutefull fullborder" style="left: 1em; right: 0.5em; border-top-width: 0 !important;">
				Checking; please wait...
			</div>
		</div>
		
		<div class="absolutefull" style="width: 33%; bottom: 10em; left: 33%;">
			<div id="validationResult1" class="absolutefull fullborder" style="left: 0.5em; right: 1em; border-top-width: 0 !important;">
			</div>
		</div>

		<div class="absolutefull" style="width: 34%; bottom: 10em; left: auto;">
			<div id="validationResult2" class="absolutefull fullborder" style="left: 0.5em; right: 1em; border-top-width: 0 !important;">
			</div>
		</div>

		<div class="absolutefull" style="top: auto; height: 10em; left: 1em; right: 1em;">
			<div id="createMissingItems" style="display:none; margin-top: 1em;">
				<base:buttongroup>
				<base:button title="Create missing items" image="add.png" onclick="createMissingItems()"/>
				</base:buttongroup>
			</div>
		
			<div id="fixIncompleteItems" style="display:none; margin-top: 1em;">
				<base:buttongroup>
				<base:button title="Fix items" image="fixit.png" onclick="createMissingItems()"/>
				</base:buttongroup>
			</div>
		
			<div class="messagecontainer error" id="errorMessage" style="display: none;"></div>
		
			<div class="messagecontainer note" id="warningMessage" style="display: none;">
				<div id="warningMessage.message"></div>
			</div>
		</div>
	
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>